SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-AcceptanceTests'!
SystemOrganization addCategory: #'SqueakSVN-Base-Test'!
SystemOrganization addCategory: #'SqueakSVN-Serializing'!
SystemOrganization addCategory: #'SqueakSVN-Serializing-Test'!
SystemOrganization addCategory: #'SqueakSVN-Test'!
SystemOrganization addCategory: #'SqueakSVN-Plugins'!

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'pe 2/22/2008 11:55'!
basicSvnAddProperty: property WithValue:value To: target
 
	<primitive: 'svnAddPropertyWithValueTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath
 
	<primitive: 'svnCheckoutHeadRevisionFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:34'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	<primitive: 'svnCheckoutRevisionByNumberFromTo' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:15'!
basicSvnCommit: collectionOfPathesToTargets
 
	<primitive: 'svnCommit' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:18'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber
 
	<primitive: 'svnUpdateTargetsToRevisionByNumber' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets
 
	<primitive: 'svnUpdateTargetsToHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:56'!
basicSvnAdd: aPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'pe 2/22/2008 11:54'!
basicSvnAddProperty: property WithValue:value To: target

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:31'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 14:35'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:57'!
basicSvnCommit: collectionOfPathsToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:58'!
basicSvnGetHeadRevision: pathToTarget

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:19'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rt 2/21/2008 15:16'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'converting' stamp: 'rt 2/5/2008 11:32'!
normalizePath: aString 

	| modifiedPath returnPath |
	modifiedPath := aString collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^(returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnAdd: aPath 

	self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'pe 2/22/2008 11:53'!
svnAddProperty: property WithValue:value To: target

	self basicSvnAddProperty: property WithValue:value To: (self normalizePath: target)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 14:31'!
svnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self basicSvnCheckoutHeadRevisionFrom: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 14:56'!
svnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath

	self basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: (self normalizePath: workingCopyPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnCommit: aCollection 

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 02:34'!
svnGetHeadRevision: aPath

	^ self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:25'!
svnUpdateTargets: aCollection toRevisionByNumber: revisionNumber

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargets: updateArray toRevisionByNumber: revisionNumber! !

!SVNClient methodsFor: 'accessing' stamp: 'rt 2/21/2008 15:21'!
svnUpdateTargetsToHeadRevision: aCollection 

	| updateArray |
	updateArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnUpdateTargetsToHeadRevision: updateArray! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:35'!
basicSvnCheckoutHeadRevisionFrom: repositoryURL to: workingCopyPath

	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:37'!
basicSvnCheckoutRevisionByNumber: revisionNumber from: repositoryURL to: workingCopyPath 

	self executeViaOSProcessSynchronously: 'svn co -r ' , revisionNumber asString , ' ' , repositoryURL , ' ' , workingCopyPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/13/2008 02:32'!
basicSvnCommit: collectionOfTargets 

	| targets |
	targets := collectionOfTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "log"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:49'!
basicSvnUpdateTargets: collectionOfPathesToTargets toRevisionByNumber: revisionNumber

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up -r', revisionNumber asString , targets! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 15:44'!
basicSvnUpdateTargetsToHeadRevision: collectionOfPathesToTargets

	| targets |
	targets := collectionOfPathesToTargets
				inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn up' , targets! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 2/13/2008 02:33'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	"Unfortunately OSProcess is platform dependent"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'rt 2/7/2008 10:56'!
normalizePath: aPath

	^'"' , (super normalizePath: aPath) , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rt 2/21/2008 14:21'!
svnGetHeadRevision: aPath

	self flag: #TODO. "Dirty hack. Extract headrevision from
	the output of the command line somehow."
	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNDirectoryEntry
	instanceVariableNames: 'theName basePath properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

SVNDirectoryEntry subclass: #SVNDirectory
	instanceVariableNames: 'subdirectories files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNDirectory methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self files = other files]) and:
			[self subdirectories = other subdirectories]! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 2/22/2008 13:49'!
createFileNamed: aString 

	| newFile |
	newFile := SVNFile
		named: aString
		basePath: self path.
	self files add: newFile.
	^ newFile! !

!SVNDirectory methodsFor: 'file manipulation' stamp: 'rkrk 2/23/2008 00:58'!
createFileNamed: filename withContent: content

	^ (self createFileNamed: filename)
		content: content;
		yourself! !

!SVNDirectory methodsFor: 'subdirectory manipulation' stamp: 'rkrk 2/22/2008 13:45'!
createSubDirectoryNamed: aString 
	
	| newDirectory |
	newDirectory := self class
		named: aString
		basePath: self path.
	self subdirectories add: newDirectory.
	^ newDirectory.! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:51'!
directoryExists: directoryName 

	^ self subdirectories anySatisfy: [:each |
		each theName = directoryName]! !

!SVNDirectory methodsFor: 'testing' stamp: 'rkrk 2/23/2008 02:35'!
fileExists: fileName

	^ self files anySatisfy: [:each | fileName = each theName].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files
	^ files! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
files: anObject
	files := anObject! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getFileNamed: fileName 
	
	^ self files
		detect: [:each | each theName = fileName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 02:55'!
getSubDirectoryNamed: directoryName 
	
	^ self subdirectories
		detect: [:each | each theName = directoryName]
		ifNone: [nil].! !

!SVNDirectory methodsFor: 'initialization' stamp: 'rkrk 2/21/2008 21:29'!
initialize

	super initialize.
	self
		files: Set new;
		subdirectories: Set new.! !

!SVNDirectory methodsFor: 'printing' stamp: 'rkrk 2/23/2008 22:05'!
printOn: aStream

	| printBlock |
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPutAll: ' - Subdirectories:'.
	printBlock := [:each |
		aStream
			nextPut: Character space;
			nextPutAll: each theName].
	self subdirectories do: printBlock.
	aStream nextPutAll: ' - Files:'.
	self files do: printBlock.
	aStream nextPut: $).! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileDirectory on: self path) exists
		ifFalse: [self error: 'There exists no directory with this name.'].
	super read.
	self readDirectoryEntries.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 22:11'!
readDirectoriesInDir: dir

	| newSvnDirectory |
	dir directoryNames do: [:each |
		newSvnDirectory := SVNDirectory
			named: each
			basePath: self path.
		newSvnDirectory read.
		self subdirectories add: newSvnDirectory].! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 22:10'!
readDirectoryEntries

	| dir |
	dir := FileDirectory on: self path.
	self
		readFilesInDir: dir;
		readDirectoriesInDir: dir.! !

!SVNDirectory methodsFor: 'reading' stamp: 'rkrk 2/21/2008 22:10'!
readFilesInDir: directory

	| newSvnFile |
	directory fileNames do: [:each |
		newSvnFile := SVNFile
			named: each
			basePath: self path.
		newSvnFile read.
		self files add: newSvnFile].! !

!SVNDirectory methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:42'!
store

	super store.
	(FileDirectory on: self path) assureExistence.
	(self files union: self subdirectories) do: [:each |
		each store].! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories
	^ subdirectories! !

!SVNDirectory methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 21:17'!
subdirectories: anObject
	subdirectories := anObject! !

!SVNDirectoryEntry class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 20:41'!
named: aString basePath: pathName

	^ self new
		theName: aString;
		basePath: pathName
		yourself.! !

!SVNDirectoryEntry methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:42'!
= other

	self species = other species ifFalse: [^ false].
	^ (self theName = other theName and:
		[self basePath = other basePath]) and:
			[self properties = other properties].! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath
	^ basePath! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
basePath: anObject 
	basePath := anObject! !

!SVNDirectoryEntry methodsFor: 'testing' stamp: 'rkrk 2/21/2008 21:42'!
hash

	^ self theName hash! !

!SVNDirectoryEntry methodsFor: 'initialization' stamp: 'rkrk 2/21/2008 20:37'!
initialize

	super initialize.
	self properties: Dictionary new.! !

!SVNDirectoryEntry methodsFor: 'derived accessing' stamp: 'rkrk 2/21/2008 20:33'!
path
	^ self basePath , FileDirectory slash , self theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties
	^ properties! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
properties: anObject
	properties := anObject! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	self	readProperties.! !

!SVNDirectoryEntry methodsFor: 'reading' stamp: 'rkrk 2/21/2008 20:35'!
readProperties
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	| contentsOfFile fullPath substrings key value |
	self flag: #TODO.
	fullPath := self basePath , FileDirectory slash , self theName , '_properties'.
	(FileStream isAFileNamed: fullPath) ifFalse: [ ^ self ].
	FileStream 
		readOnlyFileNamed: fullPath
		do: 
			[ : stream | 
			contentsOfFile := stream contents.
			contentsOfFile linesDo: 
				[ : line | 
				substrings := line subStrings: '-'.
				key := substrings first.
				value := substrings second.
				self properties 
					at: key
					put: value ] ]! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/21/2008 20:34'!
store
	
	self	storeProperties.! !

!SVNDirectoryEntry methodsFor: 'storing' stamp: 'rkrk 2/21/2008 20:34'!
storeProperties
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	| propertyFileName |
	self flag: #TODO.
	propertyFileName := self basePath , FileDirectory slash , self theName , '_properties'.
	FileStream 
		forceNewFileNamed: propertyFileName
		do: 
			[ : stream | 
			self properties keysAndValuesDo: 
				[ : key : value | 
				stream
					nextPutAll: key ;
					nextPut: $- ;
					nextPutAll: value ;
					nextPut: Character cr ].
			"Dirty. Delete last cr"
			stream size isZero not ifTrue: [ stream truncate: stream size - 1 ] ]! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName

	^ theName! !

!SVNDirectoryEntry methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 20:33'!
theName: aString 

	theName := aString.! !

SVNDirectoryEntry subclass: #SVNFile
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing'!

!SVNFile class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 20:28'!
named: aString basePath: pathName content: content

	^ (self named: aString basePath: pathName)
		content: content;
		yourself.! !

!SVNFile methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 21:44'!
= other

	^ (super = other and:
		[self content = other content])! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content
	^ content! !

!SVNFile methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 18:49'!
content: anObject
	content := anObject! !

!SVNFile methodsFor: 'initialize-release' stamp: 'rkrk 2/21/2008 21:59'!
initialize

	super initialize.
	content := String new! !

!SVNFile methodsFor: 'printing' stamp: 'rkrk 2/23/2008 21:59'!
printOn: aStream

	super printOn: aStream.	
	aStream
		nextPut: $(;
		nextPutAll: self theName;
		nextPut: $).! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:45'!
read
	
	(FileStream isAFileNamed: self path)
		ifFalse: [self error: 'There exists no file with this name!!'].
	super read.
	self	readContent.! !

!SVNFile methodsFor: 'reading' stamp: 'rkrk 2/21/2008 21:47'!
readContent

	FileStream 
		readOnlyFileNamed: self path
		do: 
			[ : stream | 
			content := stream contents.
			self ]! !

!SVNFile methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:44'!
store
	
	super store.
	FileStream 
		forceNewFileNamed: self path
		do: [:stream | stream nextPutAll: content].! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'test 2/23/2008 11:54'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'timestamp'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

Object subclass: #SVNElement
	instanceVariableNames: 'theName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'theClass superclassName classVariables instanceVariables classInstanceVariables comment category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 19:44'!
forExistingClass: aClass

	^ (self new)
		forExistingClass: aClass;
		yourself! !

!SVNClass class methodsFor: 'instance creation' stamp: 'rkrk 2/23/2008 21:47'!
forSerializedClassIn: aSVNDirectory 
	
	^ self new
		forSerializedClassIn: aSVNDirectory;
		yourself.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 12:46'!
= other

	^ self theClass = other theClass! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category
	^ category! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
category: anObject
	category := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables
	^ classInstanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classInstanceVariables: anObject
	classInstanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classInstanceVariablesString

	^ self stringFromCollection: self classInstanceVariables.! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 01:25'!
classMethods

	^ self theClass class methodDict collect: [:each |
		SVNMethod for: each].! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables
	^ classVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
classVariables: anObject
	classVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/24/2008 00:00'!
classVariablesString

	^ self stringFromCollection: self classVariables.! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment
	^ comment! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
comment: anObject
	comment := anObject! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:09'!
contentsForFile

	self flag: #TODO. "Mapping method to contents of a file"
	self flag: #TODO. "Switch to streams entirely?"
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Instance side';
			nextPut: Character cr;
			nextPutAll: self theClass superclass name;
			nextPut: Character cr;
			nextPutAll: self theClass category;
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass instVarNames);
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass classVarNames);
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass poolDictionaryNames);
			nextPut: Character cr;
			 nextPutAll: 'Class side';
			nextPut: Character cr;
			nextPutAll: (self createStringFromCollection: self theClass classSide instVarNames)].! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 2/23/2008 22:54'!
createClass: aClass withContents: contents

	| superclass |
	self flag: #TODO.
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	self theClass: (superclass
				subclass: self theName
				instanceVariableNames: self instanceVariables
				classVariableNames: self classVariables
				poolDictionaries: '' "No test!!!!!!"
				category: self category).
	self theClass classSide instanceVariableNames: self classInstanceVariables.
	^ self theClass.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/21/2008 16:40'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/23/2008 22:12'!
extractCategoryFrom: svnFile
	
	^ svnFile content lineNumber: 3.! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/23/2008 22:18'!
extractClassVarsFrom: svnFile
	
	^ (svnFile content lineNumber: 5) substrings asSet! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/23/2008 22:15'!
extractInstVarsFrom: svnFile
	
	^ (svnFile content lineNumber: 4) substrings.! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/23/2008 22:16'!
extractMetaInstVarsFrom: svnFile
	
	^ (svnFile content lineNumber: 8) substrings! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractPoolDictFrom: contents
	
	^ contents lineNumber: 6! !

!SVNClass methodsFor: 'extracting' stamp: 'rkrk 2/23/2008 22:13'!
extractSuperclassFrom: svnFile
	
	^ (svnFile content lineNumber: 2) asSymbol! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/23/2008 21:38'!
forExistingClass: aClass

	self theName: aClass name.
	self superclassName: aClass superclass name.
	self instanceVariables: aClass instVarNames.
	self classVariables: aClass classVarNames.
	self classInstanceVariables: aClass class instVarNames.
	self comment: aClass comment.
	self category: aClass category.
	
	self theClass: aClass.! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/23/2008 21:52'!
forSerializedClassIn: svnDirectory 
	
	self restoreFrom: svnDirectory.! !

!SVNClass methodsFor: 'comparing' stamp: 'rkrk 2/21/2008 12:46'!
hash

	^ self theClass hash! !

!SVNClass methodsFor: 'initialize-release' stamp: 'rkrk 2/23/2008 19:44'!
initialize

	super initialize.
	! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables
	^ instanceVariables! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
instanceVariables: anObject
	instanceVariables := anObject! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 23:59'!
instanceVariablesString

	^ self stringFromCollection: self instanceVariables.! !

!SVNClass methodsFor: 'modifying the system' stamp: 'rkrk 2/23/2008 23:54'!
load
	
	| superclass |
	self flag: #TODO.
	superclass := Smalltalk classNamed: self superclassName.
	self assert: superclass notNil.
	self theClass: (superclass
				subclass: self theName
				instanceVariableNames: self instanceVariablesString
				classVariableNames: self classVariablesString
				poolDictionaries: '' "No test!!!!!!"
				category: self category).
	self theClass classSide instanceVariableNames: self classInstanceVariablesString.! !

!SVNClass methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 01:14'!
methods

	^ self theClass methodDict collect: [:each |
		SVNMethod for: each].! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 22:20'!
nameForClassDetailsFile
	^ 'properties'! !

!SVNClass methodsFor: 'file system mapping' stamp: 'rkrk 2/23/2008 12:03'!
nameForCommentFile

	^ 'comment'! !

!SVNClass methodsFor: 'printing' stamp: 'rkrk 2/23/2008 23:52'!
printOn: aStream

	super printOn: aStream.
	aStream	nextPut: $(.
	self theName printOn: aStream.
	aStream nextPut: $).! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/13/2008 01:23'!
readCommentFrom: aPath 
	
	self flag: #TODO. "String constant in code"
	self theClass comment: (self contentsOfFileNamed: aPath , FileDirectory slash , 'comment')! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/22/2008 01:48'!
readElementFrom: aPath

	| className contents |
	className := (FileDirectory on: aPath) localName.
	contents := self readFilePropertiesFrom: aPath.
	self
		createClass: className
		withContents: contents.
	self readCommentFrom: aPath.
	self
		readMethodsFrom: aPath , FileDirectory slash , 'instance'
		for: self theClass.
	self 
		readMethodsFrom: aPath , FileDirectory slash , 'class'
		for: self theClass classSide! !

!SVNClass methodsFor: 'read' stamp: 'test 2/12/2008 13:56'!
readFilePropertiesFrom: aPath 

	^ self contentsOfFileNamed: aPath , FileDirectory slash , 'properties'! !

!SVNClass methodsFor: 'read' stamp: 'rkrk 2/13/2008 02:07'!
readMethodsFrom: aPath for: anObject 

	(FileDirectory on: aPath) fileNames do: 
			[:each | SVNMethod
				readElementFrom: aPath , FileDirectory slash , each
				for: self theClass]! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 2/23/2008 12:06'!
restoreCommentFrom: svnDirectory

	| commentFile |
	commentFile := svnDirectory getFileNamed: self nameForCommentFile.
	self flag: #TODO. "Class has to be compiled to restore the comment.
	But the idea is to have complete instances of SVNClasses that can be plugged
	in and plugged out the system without storeing or restoring. Change this!!"
	self theClass comment: commentFile content.! !

!SVNClass methodsFor: 'restoring' stamp: 'rkrk 2/23/2008 22:21'!
restoreFrom: aSVNDirectory 
	| classDetails |
	self flag: #TODO.
	classDetails := aSVNDirectory getFileNamed: self nameForClassDetailsFile.
	self
		theName: aSVNDirectory theName ;
		superclassName: (self extractSuperclassFrom: classDetails) ;
		instanceVariables: (self extractInstVarsFrom: classDetails) ;
		classVariables: (self extractClassVarsFrom: classDetails) ;
		classInstanceVariables: (self extractMetaInstVarsFrom: classDetails) ;
		"poolDictionaries: (self extractPoolDictFrom: classDetails)"	"Not test!!!!!!"
		category: (self extractCategoryFrom: classDetails);
		comment: (aSVNDirectory getFileNamed: self nameForCommentFile) content.! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:02'!
storeClassMethodsIn: svnDirectory

	| classSideDirectory |
	self flag: #TODO.	"Redundant to storing of instance methods???"
	classSideDirectory := svnDirectory createSubDirectoryNamed: 'class'
	"TODO: call store... of the methods wth classSideDirectory"! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:01'!
storeCommentIn: svnDirectory 

	svnDirectory
		createFileNamed: 'comment'
		withContent: self theClass comment.! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/23/2008 00:56'!
storeIn: svnDirectory 
	| classDirectory |
	classDirectory := svnDirectory createSubDirectoryNamed: self theClass name.
	self
		storeClassMethodsIn: classDirectory ;
		storeInstanceMethodsIn: classDirectory ;
		storeCommentIn: classDirectory ;
		storePropertiesIn: classDirectory.	"Change the name"
	"TODO: pass projectDirectory to all my elements"
	classDirectory store! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:02'!
storeInstanceMethodsIn: svnDirectory

	| classSideDirectory |
	self flag: #TODO.	"Redundant to storing of class methods???"
	classSideDirectory := svnDirectory createSubDirectoryNamed: 'instance'
	"TODO: call store... of the methods wth instanceSideDirectory"! !

!SVNClass methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:02'!
storePropertiesIn: svnDirectory 

	self flag: #TODO.	"Change the name and the hard coded string..."
	"Use properties!!!!!!"
	svnDirectory
		createFileNamed: 'properties'
		withContent: self contentsForFile.! !

!SVNClass methodsFor: 'convenience' stamp: 'rkrk 2/23/2008 23:59'!
stringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName
	^ superclassName! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:48'!
superclassName: anObject
	superclassName := anObject! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass
	^ theClass! !

!SVNClass methodsFor: 'accessing' stamp: 'rkrk 2/13/2008 01:18'!
theClass: aClass 
	theClass := aClass! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:40'!
writeClassMethodsTo: aPath 

	| path |
	path := aPath , 'class' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass classSide methodDictionary
		to: path.! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:05'!
writeCommentTo: aPath 
	
	self
		write: self theClass comment
		to: aPath , FileDirectory slash , 'comment'! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeElementTo: aPath

	| path |
	path := aPath , FileDirectory slash , self theClass name , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeClassMethodsTo: path;
		writeInstanceMethodsTo: path;
		writeCommentTo: path;
		writePropertiesTo: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:41'!
writeInstanceMethodsTo: aPath

	| path |
	path := aPath , 'instance' , FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeMethods: self theClass methodDictionary
		to: path! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:04'!
writeMethods: aMethDict to: aPath
	
	aMethDict do: [ :each | (SVNMethod for: each) writeElementTo: aPath].! !

!SVNClass methodsFor: 'write' stamp: 'rkrk 2/13/2008 01:41'!
writePropertiesTo: aPath

	self flag: #TODO "Hard coded string".
	self write: self contentsForFile to: aPath, FileDirectory slash, 'properties'! !

!SVNElement class methodsFor: 'instance creation' stamp: 'test 2/12/2008 13:34'!
readElementFrom: aPath
	^ (self new)
		readElementFrom: aPath;
		yourself! !

!SVNElement class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 12:50'!
readElementFrom: aPath for: aClass

	self flag: #TODO. "Necessary????"
	^ (self new)
		readElementFrom: aPath for: aClass;
		yourself! !

!SVNElement methodsFor: 'read' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'write' stamp: 'cop 2/12/2008 11:50'!
readElementFrom: aPath for: anObject 
	self subclassResponsibility! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:31'!
theName
	^ theName! !

!SVNElement methodsFor: 'accessing' stamp: 'rkrk 2/23/2008 19:31'!
theName: anObject
	theName := anObject! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
write: aString to: aPath

	(FileStream forceNewFileNamed: aPath )
		nextPutAll: aString;
		close.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
writeElementTo: aPath

	self subclassResponsibility.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/1/2008 02:20'!
for: aCompiledMethod 
	
	^ self methodReference: aCompiledMethod methodReference.! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 21:38'!
methodReference: aMethodReference 
	
	^ self new
		methodReference: aMethodReference;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 1/6/2008 22:07'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodClass = otherMethod methodClass &
			(self methodReference = otherMethod methodReference).! !

!SVNMethod methodsFor: 'serializing' stamp: 'cop 2/23/2008 15:54'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the category in the first line. The source code below."
	^ self methodReference category , String cr , methodReference timeStamp , String cr , self methodReference source! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/12/2008 11:42'!
extractCategoryFrom: contents

	^ contents lineNumber: 1! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/1/2008 23:23'!
extractClassFrom: contents

	| classStrings theClass |
	classStrings := (contents lineNumber: 1) substrings.
	theClass := Smalltalk at: classStrings first asSymbol.
	^ (classStrings last = 'class')
		ifTrue: [theClass class]
		ifFalse: [theClass].! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/23/2008 16:47'!
extractSourceCodeFrom: aString 
	"Do not read the first and second line, it's the protocol and timestamp."
	^ aString
		copyFrom: ((aString indexOf: Character cr startingAt: (( aString indexOf: Character cr ) + 1)) + 1)
		to: aString size! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/23/2008 15:44'!
extractTimeStampFrom: contents

	^contents lineNumber: 2.! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'mu 2/7/2008 12:57'!
fileName

	| methodName |
	methodName := self selector asString.
	methodName replaceAll: $: with: $#.
	^ methodName! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:38'!
hash

	^ self methodReference hash! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodClass
	
	^ self methodReference actualClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodReference
	
	 ^ methodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/1/2008 02:59'!
methodReference: aMethodReference 
	
	methodReference := aMethodReference.! !

!SVNMethod methodsFor: 'printing' stamp: 'rkrk 2/1/2008 11:24'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self methodReference printOn: aStream.
	aStream nextPut: $).! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/23/2008 16:53'!
readElementFrom: aPath for: aClass

	| contents sourceCode category |
	contents := self contentsOfFileNamed: aPath.
	category := self extractCategoryFrom: contents.
	sourceCode := self extractSourceCodeFrom: contents.
	self methodReference: (aClass >> (aClass compile: sourceCode
		   classified: category
		   withStamp: (self extractTimeStampFrom: contents)
		   notifying: (SyntaxError new category: category) ))
		   methodReference.! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 2/1/2008 02:58'!
selector

	^ self methodReference methodSymbol! !

!SVNMethod methodsFor: 'storing' stamp: 'rkrk 2/23/2008 01:36'!
storeIn: aSVNDirectory 
	
	aSVNDirectory
		createFileNamed: self fileName
		withContent: self contentsForFile.! !

!SVNMethod methodsFor: 'write' stamp: 'rkrk 2/13/2008 02:11'!
writeElementTo: aPath

	self
		write: self contentsForFile
		to: aPath , FileDirectory slash , self fileName.! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods projectName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject class methodsFor: 'instance creation' stamp: 'rkrk 2/21/2008 13:25'!
named: aString 
	
	^ self new
		projectName: aString;
		yourself.! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/23/2008 19:35'!
addClass: aClass

	^ self versionedClasses add: (SVNClass forExistingClass: aClass)! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/2/2008 19:22'!
addMethod: aMethod 
	
	^ self versionedMethods add: (SVNMethod for: aMethod)! !

!SVNProject methodsFor: 'derived accessing' stamp: 'rkrk 2/23/2008 01:16'!
allVersionedMethods
	
	^ self versionedClasses
		inject: self versionedMethods
		into: [:allMethods :class | allMethods addAll: class methods].! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 13:25'!
projectName
	^ projectName! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/21/2008 13:25'!
projectName: anObject
	projectName := anObject! !

!SVNProject methodsFor: 'serialization' stamp: 'rkrk 2/23/2008 00:55'!
storeIn: svnDirectory 

	| projectDirectory |
	projectDirectory := svnDirectory createSubDirectoryNamed: self projectName.
	"TODO: pass projectDirectory to all my elements"
	projectDirectory store! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:25'!
versionedMethods
	
	^ versionedMethods! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/31/2008 05:20'!
answer17

	<primitive: 'answerSeventeen' module: 'PluginAnswering17'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNClassTest methodsFor: 'assertion' stamp: 'rkrk 2/23/2008 22:18'!
assertSVNClass: aSVNClass hasStateFromSystemClass: aClass 
	
	
	self assert: aSVNClass theName = aClass name.
	self assert: aSVNClass superclassName = aClass superclass name.
	self assert: aSVNClass instanceVariables = aClass instVarNames.
	self assert: aSVNClass classVariables = aClass classVarNames.
	self assert: aSVNClass classInstanceVariables = aClass class instVarNames.
	self assert: aSVNClass comment = aClass comment.
	self assert: aSVNClass category = aClass category.! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/24/2008 00:11'!
classPropertiesForTests

	| cr |
	cr := String cr.
	^ 'Instance side' , cr , SVNDummy superclass asString , cr ,
	SVNDummy category asString , cr ,
	(self createStringFromCollection: SVNDummy instVarNames) , cr ,
	(self createStringFromCollection: SVNDummy classVarNames) , cr , cr ,
	'Class side' , cr , 
	(self createStringFromCollection: SVNDummy class instVarNames)! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/24/2008 00:25'!
configureSVNClass: svnClass forLoadingClassNamed: aString 
	
	svnClass
		theName: aString;
		superclassName: 'Object';
		instanceVariables: 'a';
		classVariables: 'A';
		classInstanceVariables: 'b';
		comment: '';
		category: self class category.! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/23/2008 02:22'!
prepareReadTest

	| pathToClass |
	pathToClass := self pathForTests , FileDirectory slash , 'SVNTest'.
	(FileDirectory on: pathToClass) assureExistence.
	self
		inFile: pathToClass, FileDirectory slash , 'comment'
		write: SVNDummy comment.
	self
		inFile: pathToClass, FileDirectory slash , 'properties'
		write: self classPropertiesForTests.
	(FileDirectory on: pathToClass , FileDirectory slash, 'instance') assureExistence.	
	(FileDirectory on: pathToClass , FileDirectory slash, 'class') assureExistence.	! !

!SVNClassTest methodsFor: 'helper' stamp: 'rkrk 2/23/2008 22:40'!
prepareReadTestForClassNamed: className

	| pathToClass |
	pathToClass := self pathForTests , FileDirectory slash , className.
	(FileDirectory on: pathToClass) assureExistence.
	self flag: #TODO. "Mapping details are spread here. Is that good?"
	self
		inFile: pathToClass, FileDirectory slash , 'comment'
		write: SVNDummy comment.
	self
		inFile: pathToClass, FileDirectory slash , 'properties'
		write: self classPropertiesForTests.
	(FileDirectory on: pathToClass , FileDirectory slash, 'instance') assureExistence.	
	(FileDirectory on: pathToClass , FileDirectory slash, 'class') assureExistence.	! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:09'!
testAllClassMethodsExists

	| path sut expectedFileNames class |
	class := SVNDummy.
	path := self pathForTests , self slash , class name asString , self slash , 'class'.
	"self ensureThatFileNotExist: path."
	sut := SVNClass forExistingClass: class.
	sut writeElementTo: self pathForTests.
	expectedFileNames := sut classMethods collect: [:each | each fileName].
	self
		assertThatFiles: expectedFileNames
		existsIn: path.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:08'!
testAllInstanceMethodsExists

	| path sut expectedFileNames class |
	self flag: #TODO.
	class := SVNDummy.
	path := self pathForTests , self slash , class name asString , self slash , 'instance'.
	"self ensureThatFileNotExist: path."
	sut := SVNClass forExistingClass: class.
	sut writeElementTo: self pathForTests.
	expectedFileNames := sut methods collect: [:each | each fileName].
	self
		assertThatFiles: expectedFileNames
		existsIn: path.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 21:43'!
testCreatingForExistingClassInitializesSVNClassCorrectly

	| sut class |
	class := SVNDummy.
	sut := SVNClass forExistingClass: class.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:10'!
testCreatingForSerializedClassInitializesSVNClassCorrectly

	| sut class classFilesCreator svnDirectory classDirectory |
	class := SVNDummy.
	classFilesCreator := SVNClass forExistingClass: class.
	svnDirectory := self defaultSVNDirectory.
	classFilesCreator storeIn: svnDirectory.
	classDirectory := (svnDirectory getSubDirectoryNamed: class name asString).
	sut := SVNClass forSerializedClassIn: classDirectory.
	self
		assertSVNClass: sut
		hasStateFromSystemClass: class.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 19:35'!
testGetSVNMethodsFromClass

	| sut expected |
	sut := SVNClass forExistingClass: SVNDummy.
	expected := sut theClass methodDict collect: [:each |
		SVNMethod for: each].
	self assert: sut methods = expected.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:28'!
testLoadClass
	
	| sut className |
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: 'SVNDummy99'.
	[sut load.
	self assert: (Smalltalk at: className) notNil.
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [ Smalltalk
				at: className
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:27'!
testReadClass
	
	| sut className |
	sut := SVNClass new.
	className := 'SVNDummy99'.
	self
		configureSVNClass: sut
		forLoadingClassNamed: 'SVNDummy99'.
	[
	sut load.
	self assert: (Smalltalk at: className) notNil.
	self flag: #TODO. "Test for the correct initialization of
	variables and comment	of the created class!!"
	] ensure: [ Smalltalk
				at: className
				ifPresent: [:class | class removeFromSystemUnlogged]].! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 19:35'!
testWriteCommentFile

	| sut svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: SVNDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storeCommentIn: svnDirectory.
	expectedFileName := 'comment'.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: SVNDummy comment = createdFile content.! !

!SVNClassTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:10'!
testWritePropertiesFile

	| sut svnDirectory expectedFileName createdFile |
	sut := SVNClass forExistingClass: SVNDummy.
	svnDirectory := self defaultSVNDirectory.
	sut storePropertiesIn: svnDirectory.
	expectedFileName := 'properties'.
	self assert: (svnDirectory fileExists: expectedFileName).
	createdFile := svnDirectory getFileNamed: expectedFileName.
	self assert: self classPropertiesForTests = createdFile content.! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: 'repositoryPath workingCopyPath fileToAdd sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:46'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/8/2008 00:54'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'pe 2/22/2008 12:33'!
testSvnAddPropertyWithValueTo

	| path fstream propertyPath propertiesContents|
	path := workingCopyPath , self slash , fileToAdd.
	propertyPath := FileDirectory on: workingCopyPath , FileDirectory slash ,'.svn', FileDirectory slash, 'props'.
	sut svnAdd: path.
	sut svnAddProperty: 'propertyName' WithValue: 'value' To: path.
	
	fstream := propertyPath readOnlyFileNamed: 'testFile.svn-work'.
	propertiesContents := fstream contents.
	fstream close.
	
	self assert: (propertiesContents includesSubString: 'propertyName').
	self assert: (propertiesContents includesSubString: 'value').
	! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 16:47'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 16:57'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:13'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rt 2/21/2008 17:08'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNClientExternalTest methodsFor: 'assert' stamp: 'rkrk 2/7/2008 15:44'!
assertWorkingCopyIncludesFile: fileName

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName).! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rt 2/22/2008 13:41'!
createRepository
	
	self assert: (FileDirectory isLegalFileName: repositoryPath).
	self deny: (FileDirectory on: repositoryPath , self slash) exists.
	
	self executeViaOSProcessSynchronously: 'svnadmin create "' , repositoryPath ,'"'.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rt 2/22/2008 13:50'!
createWorkingCopy

	| repositoryURLPath |
	self assert: (FileDirectory on: repositoryPath , self slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURLPath , ' "' , workingCopyPath , '"'! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp

	super setUp.
	repositoryPath := self pathForTests , self slash , 'repository'.
	workingCopyPath := self pathForTests , self slash , 'workingCopy'.
	self
		createRepository;
		createWorkingCopy.
	fileToAdd := 'testFile'.
	self createFile: workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 16:47'!
testSvnCheckoutHeadRevision

	| workingcopyDirectory repositoryURLPath |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutHeadRevisionFrom: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:00'!
testSvnCheckoutRevisionByNumber

	| workingcopyDirectory repositoryURLPath secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	sut svnCheckoutRevisionByNumber: 1 from: repositoryURLPath to: workingCopyPath.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:13'!
testSvnUpdateTargetsToHeadRevision

	| workingcopyDirectory |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create a new head revision"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).

	"modify the working copy"
	workingcopyDirectory deleteFileNamed: fileToAdd.
	self deny: (workingcopyDirectory fileExists: fileToAdd).

	"recover the head revision"
	sut svnUpdateTargetsToHeadRevision: (Array with: workingCopyPath).
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).! !

!SVNCommandLineClientTest methodsFor: 'as yet unclassified' stamp: 'rt 2/21/2008 17:08'!
testSvnUpdateTargetsToRevisionByNumber

	| workingcopyDirectory secondFile |
	workingcopyDirectory := FileDirectory on: workingCopyPath.
	
	"create new revisions"
	sut svnAdd: workingCopyPath , self slash , fileToAdd.
	sut svnCommit: (Array with: workingCopyPath , self slash , fileToAdd).
	
	secondFile := 'fileForSecondRevision'.
	self createFile: workingCopyPath , self slash , secondFile.
	self assert: (workingcopyDirectory fileExists: secondFile).
	sut svnAdd: workingCopyPath , self slash , secondFile.
	sut svnCommit: (Array with: workingCopyPath , self slash , secondFile).
	

	"recover the first revision"
	sut svnUpdateTargets: (Array with: workingCopyPath) toRevisionByNumber: 1.
	
	"check if successed"
	self assert: (workingcopyDirectory fileExists: fileToAdd).
	self deny: (workingcopyDirectory fileExists: secondFile).! !

SVNClientExternalTest subclass: #SVNCreateNewProjectAndCommitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-AcceptanceTests'!

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp
	"self halt."

	super setUp.
	sut := SVNCApiClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:54'!
testBackslashToSlash

	| validPath |
	validPath := sut normalizePath: 'C:\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 11:17'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := sut normalizePath: 'C:\\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:59'!
testRemoveLastSlash

	| path |
	path := sut normalizePath: 'C:\test\test\'.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNDirectoryTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNDirectoryTest methodsFor: 'running' stamp: 'rkrk 2/23/2008 01:47'!
setUp

	super setUp.
	sut := SVNDirectory
		named: 'svnDirectoryWhichIsTested'
		basePath: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/22/2008 13:47'!
testCreateFile

	| sut fileName expectedFile resultFile |
	sut := SVNDirectory
		named: 'svnDirectory'
		basePath: self pathForTests.
	fileName := 'aNewFile'.
	sut createFileNamed: fileName.
	expectedFile := SVNFile  
		named: fileName
		basePath: sut path.
	self assert: sut files size = 1.
	resultFile := sut files someElement.
	self assert: expectedFile = resultFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:48'!
testCreateSubDirectory

	| subDirectoryName expectedDirectory resultDirectory |
	subDirectoryName := 'subDirectory'.
	sut createSubDirectoryNamed: subDirectoryName.
	expectedDirectory := SVNDirectory 
		named: subDirectoryName
		basePath: sut path.
	self assert: sut subdirectories size = 1.
	resultDirectory := sut subdirectories someElement.
	self assert: expectedDirectory = resultDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:50'!
testDirectoryExists

	| directoryName |
	directoryName := 'iAmADirectory'.
	sut createSubDirectoryNamed: directoryName.
	self assert: (sut directoryExists: directoryName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:32'!
testFileExists

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	self assert: (sut fileExists: fileName).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:36'!
testGetFileNamed

	| fileName svnFile |
	fileName := 'iAmAFile'.
	svnFile := sut createFileNamed: fileName.
	self assert: (sut getFileNamed: fileName) = svnFile.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:53'!
testGetSubDirectoryNamed

	| directoryName svnDirectory |
	directoryName := 'iAmADirectory'.
	svnDirectory := sut createSubDirectoryNamed: directoryName.
	self assert: (sut getSubDirectoryNamed: directoryName) = svnDirectory.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:49'!
testReadExistingDirectory

	self
		createDirNamed: sut theName
		in: sut basePath.
	self shouldnt: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 01:50'!
testReadNonExistingDirectory

	self should: [sut read] raise: Error .! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:13'!
testRecursiveReadOnlyWithDirectories

	| subDirPath subDirName subSubDirPath subSubDirName expectedSVNSubDirectory |
	"1st level. Create real directory for the topmost SVNDirectory."
	subDirPath := self createDirNamed: sut theName in: sut basePath.
	"2nd level. Create a directory in the topmost SVNDirectory"
	subDirName := 'subdir'.
	subSubDirPath := self createDirNamed: subDirName in: subDirPath.
	"3rd level. Create a subdirectoy to the directory created just now. "
	subSubDirName := 'subsubdir'.
	self createDirNamed: subSubDirName in: subSubDirPath.
	
	"Now create the equivalent SVNDirectories"
	expectedSVNSubDirectory := SVNDirectory
		named: subDirName
		basePath: subDirPath.
	expectedSVNSubDirectory createSubDirectoryNamed: subSubDirName.
	
	sut read.
	
	self assert: sut subdirectories size = 1.
	self assert: (sut subdirectories includes: expectedSVNSubDirectory).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:17'!
testRecursiveReadOnlyWithFiles

	| fileName content pathToFile expectedSvnFile |
	"Create real directory"
	self	createDirNamed: sut theName in: sut basePath.
	"Create a file"
	fileName := 'someFile'.
	content := 'blupfi'.
	pathToFile := self createPathToFile: fileName inDirectory: sut path.
	self inFile: pathToFile write: content.
	"Create SVNFile equivalent"
	expectedSvnFile := SVNFile
		named: fileName
		basePath: sut path
		content: content.
	"exercise"
	sut read.
	self assert: (sut files includes: expectedSvnFile).! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:18'!
testStoreDirectory

	sut store.
	self
		assertThatDirectories: {sut theName}
		existsIn: self pathForTests.! !

!SVNDirectoryTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 02:19'!
testStoreDirectoryWithFile

	| fileName |
	fileName := 'iAmAFile'.
	sut createFileNamed: fileName.
	sut store.
	self
		assertThatFiles: {fileName}
		existsIn: sut path.! !

SVNTestCase subclass: #SVNFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Serializing-Test'!

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testReadFileContents

	| sut fileName content fullPath |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self assert: sut content isEmpty.
	content := 'blabla' , String cr , 'blupf blupf'.
	fullPath := self createPathToFile: fileName inDirectory: self pathForTests.
	self inFile: fullPath write: content.
	sut read.
	self assert: sut content = content.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:57'!
testReadFileProperties

	| sut fileName content fullPath propertyDict |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self assert: sut properties isEmpty.
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	content := 'key1-value1' , String cr , 'key2-value2'.
	fullPath := self createPathToFile: fileName , '_properties' inDirectory: self pathForTests.
	self inFile: fullPath write: content.
	sut readProperties.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	self assert: sut properties = propertyDict.! !

!SVNFileTest methodsFor: 'tests' stamp: 'test 2/21/2008 20:59'!
testReadNonExistingFile

	| sut fileName |
	fileName := 'someSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	self should: [sut read] raise: Error .! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testStoreAsFile

	| sut fileName |
	fileName := 'testSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	sut store.
	self assertThatFiles: {fileName} existsIn: self pathForTests.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testStoreContent

	| sut fileName content |
	fileName := 'otherSVNFile'.
	content := 'this is content' , String cr , 'much content'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests
		content: content.
	sut store.
	self
		assertThatFile: fileName
		inPath: self pathForTests
		hasContent: content.! !

!SVNFileTest methodsFor: 'tests' stamp: 'rkrk 2/21/2008 20:29'!
testStoreProperties

	| sut fileName propertyDict expectedContent |
	fileName := 'otherSVNFile'.
	sut := SVNFile
		named: fileName
		basePath: self pathForTests.
	propertyDict := Dictionary new.
	propertyDict at: 'key1' put: 'value1'.
	propertyDict at: 'key2' put: 'value2'.
	sut properties: propertyDict.
	sut store.
	"Dirty hack for now. Store properties in a new file
	with 'properties' appended to the actual filename."
	expectedContent := 'key1-value1' , String cr , 'key2-value2'.
	self
		assertThatFile: fileName , '_properties'
		inPath: self pathForTests
		hasContent: expectedContent.! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNMethodTest methodsFor: 'running' stamp: 'rkrk 2/24/2008 00:29'!
tearDown

	super tearDown.
	SVNDummy methodDict
		at: #m2
		ifAbsent: [SVNDummy compile: SVNDummy sourceCodeForM2]! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 00:29'!
testContentsToWrite
	| method expected result |
	method := SVNMethod for: SVNDummy >> #m1.
	expected := 'dummy methods
test 2/23/2008 11:54
m1
	^ 1'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 00:29'!
testContentsToWriteCaseMetaClass
	| method expected result |
	method := SVNMethod for: SVNDummy class >> #m3.
	expected := 'dummy
cop 2/7/2008 19:50
m3

	^ 3'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:36'!
testEquals

	| methodBlock method1 method2 |
	methodBlock := [SVNMethod for: SVNDummy >> #m1].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 00:37'!
testExtractMetaClass

	| source method result expected |
	method := SVNMethod new.
	self flag: #TODO. "Implicitly specified mapping..."
	source := 'SVNDummy class' ,  String cr , 'dummy' , String cr , 'timestamp'  , String cr , 'm4 ^ 4'.
	result := method extractClassFrom: source.
	expected := SVNDummy class.
	self assert: result = expected.! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'rkrk 2/24/2008 00:38'!
testRead

	| method expectedSource methodName fileName cr |
	methodName := 'm2'.
	cr := String cr.
	expectedSource := 'dummy methods' , cr , 'timestamp' , cr , SVNDummy sourceCodeForM2.
	SVNDummy removeSelector: methodName asSymbol.
	fileName := self pathForTests , FileDirectory slash , methodName.
	self inFile: fileName write: expectedSource.
	method := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: expectedSource = method contentsForFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 00:34'!
testWrite

	| method expected svnDir methodFile |
	method := SVNMethod for: SVNDummy >> #methodWithSpecialCharacter:.
	svnDir := self defaultSVNDirectory.
	method storeIn: svnDir.
	expected := 'dummy methods
cop 2/7/2008 19:50
methodWithSpecialCharacter: aString
	^ aString'.
	methodFile := svnDir getFileNamed: method fileName. 
	self assert: methodFile notNil.
	self assert: methodFile content = expected.! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'rkrk 2/24/2008 00:30'!
testWriteRead
	| method fileName readMethod |
	method := SVNMethod for: SVNDummy >> #m1.
	fileName := self createPathToFile: method fileName
				inDirectory: self pathForTests.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	readMethod := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: method = readMethod.
	self ensureThatFileNotExist: fileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base-Test'!

!SVNProjectTest methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 13:31'!
assertExistanceOfProject: aSVNProject in: pathString

	| dir |
	dir := FileDirectory on: pathString.
	self assert: (dir directoryExists: aSVNProject projectName).! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 19:35'!
testAddClass

	| sut aClass methodsOfClass result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: (SVNClass forExistingClass: aClass)).
	methodsOfClass := aClass methodDict collect: [ : ea | SVNMethod for: ea ].
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/24/2008 00:30'!
testAddMethod
	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod methodClass = aMethod methodClass.
	self assert: svnMethod selector = aMethod selector! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 00:54'!
testMappingToFileSystem01
	| sut |
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeIn: self defaultSVNDirectory.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNProjectTest methodsFor: 'tests' stamp: 'rkrk 2/23/2008 00:54'!
testMappingToFileSystem02
	| sut |
	self flag: #TODO.	"Add SVNElements"
	sut := SVNProject named: 'SVNProjectWhichIsSerialized'.
	sut storeIn: self defaultSVNDirectory.
	self 
		assertExistanceOfProject: sut
		in: self pathForTests! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatDirectories: dirNames existsIn: path

	dirNames do: [:each |
		self assert: ((FileDirectory on: path) directoryExists: each)] .! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 19:16'!
assertThatFile: fileName inPath: pathName hasContent: expectedContent

	| fullPath actualContent |
	fullPath := self createPathToFile: fileName inDirectory: pathName.
	self assert: (FileStream isAFileNamed: fullPath).
	actualContent := (FileStream readOnlyFileNamed: fullPath) contentsOfEntireFile.
	self assert: actualContent = expectedContent.! !

!SVNTestCase methodsFor: 'assertion' stamp: 'rkrk 2/21/2008 20:48'!
assertThatFiles: fileNames existsIn: path

	fileNames do: [:each |
		self assert: ((FileDirectory on: path) fileExists: each)] .! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/21/2008 21:50'!
createDirNamed: newDirName in: existingDir 
	
	(FileDirectory on: existingDir) assureExistenceOfPath: newDirName.
	^ existingDir , FileDirectory slash , newDirName.! !

!SVNTestCase methodsFor: 'write files' stamp: 'rkrk 2/1/2008 15:34'!
createPathToFile: filename inDirectory: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/21/2008 16:41'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNTestCase methodsFor: 'please change me' stamp: 'rkrk 2/22/2008 14:49'!
defaultSVNDirectory
	
	^ SVNDirectory
		named: 'svnTests'
		basePath: SmalltalkImage current imagePath! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:30'!
ensureThatFileNotExist: fileName

	FileDirectory deleteFilePath: fileName! !

!SVNTestCase methodsFor: 'OSProcess' stamp: 'rkrk 2/7/2008 13:51'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNTestCase methodsFor: 'write files' stamp: 'test 2/12/2008 12:36'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.

	! !

!SVNTestCase methodsFor: 'default' stamp: 'cop 2/12/2008 11:24'!
pathForTests

	"If you touch the path, reset it before commit!!'"
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNTestCase methodsFor: 'read files' stamp: 'cop 2/5/2008 11:33'!
readFileFrom: aDir fileName: aString

	| stream contents |
	stream := aDir oldFileNamed: aString.
	contents := stream contents.
	stream close.
	^contents! !

!SVNTestCase methodsFor: 'SVNDummy' stamp: 'rkrk 2/23/2008 23:45'!
restoreSVNDummy

	"Read a file out of SVNDummy. If you change the class, replace this fileout."
	| stream |
	stream :=  ReadWriteStream with: '''From Squeak3.9 of 7 November 2006 [latest update: #7067] on 23 February 2008 at 11:10:05 pm''!!
Object subclass: #SVNDummy
	instanceVariableNames: ''i1 i2''
	classVariableNames: ''C1 C2''
	poolDictionaries: ''''
	category: ''SqueakSVN-Base-Test''!!
!!SVNDummy commentStamp: ''<historical>'' prior: 0!!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!!


!!SVNDummy methodsFor: ''dummy methods'' stamp: ''test 2/23/2008 11:54''!!
m1
	^ 1!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''timestamp''!!
m2
	^ 2!! !!

!!SVNDummy methodsFor: ''dummy methods'' stamp: ''cop 2/7/2008 19:50''!!
methodWithSpecialCharacter: aString
	^ aString!! !!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!

SVNDummy class
	instanceVariableNames: ''IC1 IC2''!!

!!SVNDummy class methodsFor: ''dummy'' stamp: ''cop 2/7/2008 19:50''!!
m3

	^ 3!! !!


!!SVNDummy class methodsFor: ''convenience'' stamp: ''cop 2/7/2008 19:50''!!
sourceCodeForM2
	^ ''m2
	^ 2''!! !!
'.
	stream
		reset;
		fileInAnnouncing: 'Restoring SVNDummy';
		close.! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/12/2008 14:59'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:24'!
slash

	^ FileDirectory slash! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/3/2008 22:43'!
tearDown

	super tearDown.
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [(FileDirectory on: self pathForTests) recursiveDelete]
		ifTrue: [self executeViaOSProcessSynchronously: 'delete_svnTests.bat'].! !
